import { defineAccessMatrix, useAccess } from '@scripts/hooks';

export const accessMatrix = defineAccessMatrix({
    LIST: {
        // Пользователю доступен табличный список с фильтрами и поиском
        view: 201,
    },
    ID: {
        // Пользователю доступная детальна страница возврата
        view: 202,
        // Пользователю доступна вкладка "Главное" для просмотра
        main: {
            view: 203,
            // Пользователю доступна функция изменение ответственного за возврат во вкладке "Главное" + кнопки "Сохранить"/"Отменить"
            editResponsibleForRefund: 207,
        },
        // Пользователю доступна вкладка "Товары" для просмотра
        products: {
            view: 204,
        },
        // Пользователю доступна вкладка "Вложения" для просмотра
        attachments: {
            view: 205,
            // Пользователю доступна функция загрузка вложений  во вкладке "Вложения" + кнопки "Сохранить"/"Отменить"
            create: 208,
            // Пользователю доступна функция удаления вложений  во вкладке "Вложения" + кнопки "Сохранить"/"Отменить"
            delete: 209,
        },
        // Пользователю доступно только редактирование данных возврата (без действий)
        edit: 206,
        settings: {
            // Пользователю доступен табличный список с причинами возврата по кнопке "Настройка причин возврата"
            view: 210,
            // Пользователю доступно создание причин возврата + кнопка "Добавить причину"
            create: 211,
            // Пользователю доступно редактирование причин возврата + кнопка "Изменить причину"
            edit: 212,
        },
    },
});

export const useRefundsAccess = () => {
    const access = useAccess(accessMatrix);
    const canViewAnyPartOfDetailPage =
        access.ID.view || access.ID.main.view || access.ID.products.view || access.ID.attachments.view;

    return { access, canViewAnyPartOfDetailPage };
};
